Agora C++ API Reference for All Platforms

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Public Attributes | List of all members
agora::media::base::ExternalVideoFrame Struct Reference

`#include <AgoraMediaBase.h>`

## Public Types
enum | EGL_CONTEXT_TYPE { EGL_CONTEXT10 = 0 , EGL_CONTEXT14 = 1 }
enum | VIDEO_BUFFER_TYPE { VIDEO_BUFFER_RAW_DATA = 1 , VIDEO_BUFFER_ARRAY = 2 , VIDEO_BUFFER_TEXTURE = 3 }

## Public Member Functions
| ExternalVideoFrame ()

## Public Attributes
VIDEO_BUFFER_TYPE | type
VIDEO_PIXEL_FORMAT | format
void * | buffer
int | stride
int | height
int | cropLeft
int | cropTop
int | cropRight
int | cropBottom
int | rotation
long long | timestamp
void * | eglContext
EGL_CONTEXT_TYPE | eglType
int | textureId
long long | fenceObject
float | matrix [16]
uint8_t * | metadataBuffer
int | metadataSize
uint8_t * | alphaBuffer
bool | fillAlphaBuffer
ALPHA_STITCH_MODE | alphaStitchMode
void * | d3d11Texture2d
int | textureSliceIndex
Hdr10MetadataInfo | hdr10MetadataInfo
ColorSpace | colorSpace

## Detailed Description

The definition of the ExternalVideoFrame struct.

## Member Enumeration Documentation

## ◆ EGL_CONTEXT_TYPE

enum agora::media::base::ExternalVideoFrame::EGL_CONTEXT_TYPE

The EGL context type.

Enumerator
EGL_CONTEXT10 | 0: When using the OpenGL interface (javax.microedition.khronos.egl.*) defined by Khronos
EGL_CONTEXT14 | 0: When using the OpenGL interface (android.opengl.*) defined by Android

## ◆ VIDEO_BUFFER_TYPE

enum agora::media::base::ExternalVideoFrame::VIDEO_BUFFER_TYPE

Video buffer types.

Enumerator
VIDEO_BUFFER_RAW_DATA | 1: Raw data.
VIDEO_BUFFER_ARRAY | 2: The same as VIDEO_BUFFER_RAW_DATA.
VIDEO_BUFFER_TEXTURE | 3: The video buffer in the format of texture.

## Constructor & Destructor Documentation

## ◆ ExternalVideoFrame()

agora::media::base::ExternalVideoFrame::ExternalVideoFrame | ( |  | ) |
| inline

## Member Data Documentation

## ◆ type

VIDEO_BUFFER_TYPE agora::media::base::ExternalVideoFrame::type

The buffer type: VIDEO_BUFFER_TYPE.

## ◆ format

VIDEO_PIXEL_FORMAT agora::media::base::ExternalVideoFrame::format

The pixel format: VIDEO_PIXEL_FORMAT

## ◆ buffer

void* agora::media::base::ExternalVideoFrame::buffer

The video buffer.

## ◆ stride

int agora::media::base::ExternalVideoFrame::stride

The line spacing of the incoming video frame (px). For texture, it is the width of the texture.

## ◆ height

int agora::media::base::ExternalVideoFrame::height

The height of the incoming video frame.

## ◆ cropLeft

int agora::media::base::ExternalVideoFrame::cropLeft

[Raw data related parameter] The number of pixels trimmed from the left. The default value is 0.

## ◆ cropTop

int agora::media::base::ExternalVideoFrame::cropTop

[Raw data related parameter] The number of pixels trimmed from the top. The default value is 0.

## ◆ cropRight

int agora::media::base::ExternalVideoFrame::cropRight

[Raw data related parameter] The number of pixels trimmed from the right. The default value is 0.

## ◆ cropBottom

int agora::media::base::ExternalVideoFrame::cropBottom

[Raw data related parameter] The number of pixels trimmed from the bottom. The default value is 0.

## ◆ rotation

int agora::media::base::ExternalVideoFrame::rotation

[Raw data related parameter] The clockwise rotation information of the video frame. You can set the rotation angle as 0, 90, 180, or 270. The default value is 0.

## ◆ timestamp

long long agora::media::base::ExternalVideoFrame::timestamp

The timestamp (ms) of the incoming video frame. An incorrect timestamp results in a frame loss or unsynchronized audio and video.

Please refer to getAgoraCurrentMonotonicTimeInMs or getCurrentMonotonicTimeInMs to determine how to fill this filed.

## ◆ eglContext

void* agora::media::base::ExternalVideoFrame::eglContext

[Texture-related parameter] When using the OpenGL interface (javax.microedition.khronos.egl.*) defined by Khronos, set EGLContext to this field. When using the OpenGL interface (android.opengl.*) defined by Android, set EGLContext to this field.

## ◆ eglType

EGL_CONTEXT_TYPE agora::media::base::ExternalVideoFrame::eglType

[Texture related parameter] Texture ID used by the video frame.

## ◆ textureId

int agora::media::base::ExternalVideoFrame::textureId

[Texture related parameter] Incoming 4 × 4 transformational matrix. The typical value is a unit matrix.

## ◆ fenceObject

long long agora::media::base::ExternalVideoFrame::fenceObject

[Texture related parameter] The fence object related to the textureId parameter, indicating the synchronization status of the video data in Texture format. The default value is 0

## ◆ matrix

float agora::media::base::ExternalVideoFrame::matrix[16]

[Texture related parameter] Incoming 4 × 4 transformational matrix. The typical value is a unit matrix.

## ◆ metadataBuffer

uint8_t* agora::media::base::ExternalVideoFrame::metadataBuffer

[Texture related parameter] The MetaData buffer. The default value is NULL

## ◆ metadataSize

int agora::media::base::ExternalVideoFrame::metadataSize

[Texture related parameter] The MetaData size. The default value is 0

## ◆ alphaBuffer

uint8_t* agora::media::base::ExternalVideoFrame::alphaBuffer

Indicates the alpha channel of current frame, which is consistent with the dimension of the video frame. The value range of each pixel is [0,255], where 0 represents the background; 255 represents the foreground. The default value is NULL.

## ◆ fillAlphaBuffer

bool agora::media::base::ExternalVideoFrame::fillAlphaBuffer

[For bgra or rgba only] Extract alphaBuffer from bgra or rgba data. Set it true if you do not explicitly specify the alphabuffer. The default value is false

## ◆ alphaStitchMode

ALPHA_STITCH_MODE agora::media::base::ExternalVideoFrame::alphaStitchMode

The relative position between alphabuffer and the frame. 0: Normal frame; 1: Alphabuffer is above the frame; 2: Alphabuffer is below the frame; 3: Alphabuffer is on the left of frame; 4: Alphabuffer is on the right of frame; The default value is 0.

## ◆ d3d11Texture2d

void* agora::media::base::ExternalVideoFrame::d3d11Texture2d

[For Windows only] The pointer of ID3D11Texture2D used by the video frame.

## ◆ textureSliceIndex

int agora::media::base::ExternalVideoFrame::textureSliceIndex

[For Windows only] The index of ID3D11Texture2D array used by the video frame.

## ◆ hdr10MetadataInfo

Hdr10MetadataInfo agora::media::base::ExternalVideoFrame::hdr10MetadataInfo

metadata info used for hdr video data

## ◆ colorSpace

ColorSpace agora::media::base::ExternalVideoFrame::colorSpace

The ColorSpace of the video frame.